#ifndef LAZY_MPL_DROP_HPP_VK_20043010
#define LAZY_MPL_DROP_HPP_VK_20043010

// (C) Copyright Vesa Karvonen 2004.
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE.)

#include "lazy_mpl/int.hpp"
#include "lazy_mpl/list.hpp"

// `DROP<n, l>' evaluates to the list `l' without the first `n'
// elements.
template<class n, class l>
struct DROP
  : IF<IS_0<n>,
       l,
       DROP<PRED<n>,
            TAIL<l> > > {};

#endif
