#ifndef TEST_HPP_VK_20043010
#define TEST_HPP_VK_20043010

// (C) Copyright Vesa Karvonen 2004.
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE.)

#include "lazy_mpl/bool.hpp"

namespace detail {
  template<class l, class r>
  struct is_same
    : FALSE {};

  template<class t>
  struct is_same<t, t>
    : TRUE {};
}

template<class result, class expr>
struct test {
  typedef int type[ detail::is_same<result, typename expr::type >::value ? 1 : -1 ];
};

#define TEST ::type TEST_CAT(test_, __LINE__)
#define TEST_CAT(l, r) TEST_PRIMITIVE_CAT(l, r)
#define TEST_PRIMITIVE_CAT(l, r) l##r

#endif
