#ifndef LAZY_MPL_APPEND_HPP_VK_20043010
#define LAZY_MPL_APPEND_HPP_VK_20043010

// (C) Copyright Vesa Karvonen 2004.
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE.)

#include "lazy_mpl/list.hpp"

// `APPEND<l, r>' appends the list `r' to the end of the list `l'.
template<class l, class r>
struct APPEND
  : IF<IS_NIL<l>,
       r,
       CONS<HEAD<l>,
            APPEND<TAIL<l>, r> > > {};

#endif
