#ifndef LAZY_MPL_ITERATE_HPP_VK_20043010
#define LAZY_MPL_ITERATE_HPP_VK_20043010

// (C) Copyright Vesa Karvonen 2004.
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE.)

#include "lazy_mpl/list.hpp"
#include "lazy_mpl/apply.hpp"

// `ITERATE<f, x>' evaluates to the infinite list
// `CONS<x, ITERATE<f, APPLY<f, x> > >'.
template<class f, class x>
struct ITERATE
  : CONS<x,
         ITERATE<f, APPLY<f, x> > > {};

#endif
